/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.gui.widgets;

import org.apache.log4j.Logger;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author szpak
 */
public class SectionHeaderTestFrame extends javax.swing.JFrame
{
    private static final Logger LOGGER = Logger.getLogger(SectionHeaderTestFrame.class);

    /**
     * Creates new form SectionHeaderTestFrame
     */
    public SectionHeaderTestFrame()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        sectionHeader1 = new org.visnow.vn.gui.widgets.SectionHeader();
        enabledToggleButton = new javax.swing.JToggleButton();
        expandableToggleButton = new javax.swing.JToggleButton();
        showCheckboxToggleButton = new javax.swing.JToggleButton();
        selectableToggleButton = new javax.swing.JToggleButton();
        showSeparatorToggleButton = new javax.swing.JToggleButton();
        showIconToggleButton = new javax.swing.JToggleButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        sectionHeader1.setText("Section header 1");
        sectionHeader1.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                sectionHeader1UserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(sectionHeader1, gridBagConstraints);

        enabledToggleButton.setSelected(true);
        enabledToggleButton.setText("enabled");
        enabledToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                enabledToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(enabledToggleButton, gridBagConstraints);

        expandableToggleButton.setSelected(true);
        expandableToggleButton.setText("expandable");
        expandableToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                expandableToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(expandableToggleButton, gridBagConstraints);

        showCheckboxToggleButton.setSelected(true);
        showCheckboxToggleButton.setText("checkbox");
        showCheckboxToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                showCheckboxToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(showCheckboxToggleButton, gridBagConstraints);

        selectableToggleButton.setSelected(true);
        selectableToggleButton.setText("selectable");
        selectableToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectableToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(selectableToggleButton, gridBagConstraints);

        showSeparatorToggleButton.setSelected(true);
        showSeparatorToggleButton.setText("separator");
        showSeparatorToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                showSeparatorToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(showSeparatorToggleButton, gridBagConstraints);

        showIconToggleButton.setSelected(true);
        showIconToggleButton.setText("icon");
        showIconToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                showIconToggleButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(showIconToggleButton, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void enabledToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_enabledToggleButtonActionPerformed
    {//GEN-HEADEREND:event_enabledToggleButtonActionPerformed
        sectionHeader1.setEnabled(enabledToggleButton.isSelected());
    }//GEN-LAST:event_enabledToggleButtonActionPerformed

    private void showSeparatorToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showSeparatorToggleButtonActionPerformed
    {//GEN-HEADEREND:event_showSeparatorToggleButtonActionPerformed
        sectionHeader1.setShowSeparator(showSeparatorToggleButton.isSelected());
    }//GEN-LAST:event_showSeparatorToggleButtonActionPerformed

    private void expandableToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_expandableToggleButtonActionPerformed
    {//GEN-HEADEREND:event_expandableToggleButtonActionPerformed
        sectionHeader1.setExpandable(expandableToggleButton.isSelected());
    }//GEN-LAST:event_expandableToggleButtonActionPerformed

    private void showIconToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showIconToggleButtonActionPerformed
    {//GEN-HEADEREND:event_showIconToggleButtonActionPerformed
        sectionHeader1.setShowIcon(showIconToggleButton.isSelected());
    }//GEN-LAST:event_showIconToggleButtonActionPerformed

    private void showCheckboxToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showCheckboxToggleButtonActionPerformed
    {//GEN-HEADEREND:event_showCheckboxToggleButtonActionPerformed
        sectionHeader1.setShowCheckBox(showCheckboxToggleButton.isSelected());
    }//GEN-LAST:event_showCheckboxToggleButtonActionPerformed

    private void sectionHeader1UserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_sectionHeader1UserChangeAction
    {//GEN-HEADEREND:event_sectionHeader1UserChangeAction
        LOGGER.debug((sectionHeader1.isExpanded() ?  "expanded" : "collapsed") + " " + (sectionHeader1.isSelected() ? "selected" : "deselected") + " EventType: " + evt.getEventType());
    }//GEN-LAST:event_sectionHeader1UserChangeAction

    private void selectableToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectableToggleButtonActionPerformed
    {//GEN-HEADEREND:event_selectableToggleButtonActionPerformed
        sectionHeader1.setSelectable(selectableToggleButton.isSelected());
    }//GEN-LAST:event_selectableToggleButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        VisNow.initLogging(true);
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(SectionHeaderTestFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(SectionHeaderTestFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(SectionHeaderTestFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(SectionHeaderTestFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                final SectionHeaderTestFrame f = new SectionHeaderTestFrame();
                f.setSize(f.getWidth() + 40, f.getHeight() + 10);
                f.setLocationRelativeTo(null);
                f.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton enabledToggleButton;
    private javax.swing.JToggleButton expandableToggleButton;
    private org.visnow.vn.gui.widgets.SectionHeader sectionHeader1;
    private javax.swing.JToggleButton selectableToggleButton;
    private javax.swing.JToggleButton showCheckboxToggleButton;
    private javax.swing.JToggleButton showIconToggleButton;
    private javax.swing.JToggleButton showSeparatorToggleButton;
    // End of variables declaration//GEN-END:variables
}
